using FileHandlers;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Options;
using SqlSugar;

namespace FileStorage.Host.Controllers
{
    [ApiController]
    [Route("weather")]
    public class WeatherForecastController : ControllerBase
    {

        private static readonly string[] Summaries = new[]
        {
        "Freezing", "Bracing", "Chilly", "Cool", "Mild", "Warm", "Balmy", "Hot", "Sweltering", "Scorching"
         };

        private readonly ILogger<WeatherForecastController> _logger;
        private readonly IFwFileProvider _fwFileProvider;

        public WeatherForecastController(ILogger<WeatherForecastController> logger, IFwFileProvider fwFileProvider)
        {
            _logger = logger;
            _fwFileProvider = fwFileProvider;
        }

        [HttpGet(Name = "GetWeatherForecast")]
        public IEnumerable<WeatherForecast> Get()
        {
            return Enumerable.Range(1, 5).Select(index => new WeatherForecast
            {
                Date = DateOnly.FromDateTime(DateTime.Now.AddDays(index)),
                TemperatureC = Random.Shared.Next(-20, 55),
                Summary = Summaries[Random.Shared.Next(Summaries.Length)]
            })
            .ToArray();
        }

        [HttpPost("upload")]
        public IActionResult Upload()
        {
            var fileData = Request.Form.Files[0];
            var file = _fwFileProvider.Upload(fileData.FileName, fileData.Length, "",fileData.OpenReadStream());
            return Ok(new { Id = file.GetID(), fileName = file.FileName });
            
        }
    }
}